#!/usr/local/bin/perl

$motv = 0;
$mkuv = 0;

while ($ARGV[0] =~ /\-/){
	if ($ARGV[0] eq "-mot"){
		$motv = 1;
		shift ;
		next ;
	}elsif ($ARGV[0] eq "-mku"){
		$mkuv = 1;
		shift ;
		next ;
	}else{
		print STDOUT "Unknown Option $ARGV[0]. Abnormal End.\n";
		exit -1;
	}
}

$header_v = 1;

while (<>){

	if (/^o^|Cg/){
		if ($header_v != 0){
			print "<?xml version=\"1.0\" encoding=\"Shift_JIS\"?>\n" ;
			$header_v = 0 ;
		}	
		next;
	}

	s/#//g ;

	@tmp = split(/\t/);

	$org_lon  = $tmp[3];
	$org_lat  = $tmp[4];
	$sys      = $tmp[12];
	$org_dir  = $tmp[14];

	$loc      = $tmp[17];
	$comment  = $loc ;
	if ($tmp[18] ne ''){
		$comment = $comment . " ". $tmp[18];
	}

	$org_time = $tmp[21];

#lon convert
	$org_lon =~ /([0-9][0-9][0-9])([0-9][0-9])([0-9][0-9])([0-9])/ ;
	$lon = "$1,$2,$3.$4" . "00" ;

	#lat convert
	$org_lat =~ /0([0-9][0-9])([0-9][0-9])([0-9][0-9])([0-9])/ ;
	$lat = "$1,$2,$3.$4" . "00" ;

# I[rX or ܂ (I[rX = 0, ܂ = 1)
	$style = 0 ;

	if ( ($sys =~ /N/) || ($sys =~ /LN/) || ($sys =~ /N/) ){
		$style = 1;
		$attr_sys = "sys" ;
		$attr_type = "type" ;
	}else{
		$attr_sys = "orvis-sys" ;
		$attr_type = "orvis-type" ;
	}

# H or LH or ʓH 

	if ( $sys =~ // ){
		$type = "LH" ;
		if ($mkuv == 0){
			$category = "H" ;
		}else{
			$category = "LH" ;
		}
	}elsif ( $sys =~ /L/ ){
		$type = "LH" ;
		$category = "LH" ;
	}else{
		$type = "ʓH" ;
		$category = "ʓH" ;
	}

# category
	if ($motv ==0){
		if ($style == 0){
			$category = $category . "I[rX" ;
		}else{
			$category = $category . "" ;
		}
	}

# ipx
	if ($style == 0){
		$dir = ( ($org_dir * 45) + 180 ) % 360 ;
		$attr_dir = "orvis-dir" ;
	}else{
		$dir = '' ;
		$attr_dir = "dir" ;
	}

# o^
	$org_time =~ /([0-9][0-9][0-9][0-9])([0-9][0-9])([0-9][0-9])([0-9][0-9])([0-9][0-9])([0-9][0-9])/;
	$time = "$1-$2-$3T$4:$5:$6:00+9:00" ;

# o͕
	$poi =        "<poix_ex><poix><format><datum>tokyo</datum><unit>dms</unit>" ;
	$poi = $poi . "<time>$time</time>" ;
	$poi = $poi . "</format><poi><point><pos>" ;
	$poi = $poi . "<lon>$lon</lon><lat>$lat</lat>" ;
	$poi = $poi . "<name style=\"formal\"><nb>$loc</nb></name>" ;
	$poi = $poi . "<db_use><db_name></db_name><db_index></db_index></db_use></pos></point>" ;
	$poi = $poi . "<name style=\"formal\"><nb>$loc</nb></name>" ;
	$poi = $poi . "<contact href=\"tel:\"></contact><note attr=\"address\"></note>" ;
	$poi = $poi . "<note attr=\"comment\">$comment</note>";
	$poi = $poi . "<note attr=\"$attr_sys\">$sys</note>" ;
	$poi = $poi . "<note attr=\"$attr_dir\">$dir</note>";
	$poi = $poi . "<note attr=\"$attr_type\">$type</note>" ;
	$poi = $poi . "<category>$category</category>" ;
	$poi = $poi . "<mate href=\"\"></mate></poi></poix></poix_ex>\n" ;

	print $poi ;
}
#
